-------------------------------------------------------------- 
--  VIRT 1.1
--  Subject : DAO. Database object
--  Copyright (c) 2000 by A.Baranovsky
--------------------------------------------------------------

uses dao, daorec, daoqdef, daotdef, daorel

class Database : DAOObject
  function "DAOObject"( X )
  function Close()
  function CreateProperty()
  function CreateQueryDef( Name, SQLText )
  function CreateRelation( Name, Table, ForeignTable, Attributes )
  function CreateTableDef( Name, Attributes, Source, Connect )
  function Execute( Source, Options )
  function MakeReplica( Replica, Description, Options )
  function NewPassword( OldPwd, NewPwd )
  function OpenRecordset( RecordsetName, OpenMode, Options, Lockedits )
  function Synchronize( Pathname, Exchange )
// Use GetProp and SetProp methods of DAOObject class to read/write 
// properties of a Database object
end

implementation Database

  function "DAOObject"( X )
    SetRef( X.GetRef() )
  return Self()

  function OpenRecordset( RecordsetName, OpenMode, Options, Lockedits )
    object RS : Recordset
    RS.SetRef( Call( 'OpenRecordset', [ RecordsetName, OpenMode, Options, Lockedits ] ) )
  return RS

  function CreateTableDef( Name, Attributes, Source, Connect )
    object TD : TableDef
    TD.SetRef( Call( 'CreateTableDef', [ Name, Attributes, Source, Connect ] ) )
  return TD

  function CreateRelation( Name, Table, ForeignTable, Attributes )
    object R : Relation
    R.SetRef( Call( 'CreateRelation', [ Name, Table, ForeignTable, Attributes ] ) )
  return R

  function CreateQueryDef( Name, SQLText )
    object QD : QueryDef
    QD.SetRef( Call( 'CreateQueryDef', [ Name, SQLText ] ) )
  return QD

  function CreateProperty()
    object P : Property
    P.SetRef( Call( 'CreateProperty', [] ) )
  return P

  function Execute( Source, Options )
  return Call( 'Execute', [ Source, Options ] )

  function MakeReplica( Replica, Description, Options )
  return Call( 'MakeReplica', [ Replica, Description, Options ] )

  function Close()
  return Call( 'Close', [] )

  function NewPassword( OldPwd, NewPwd )
  return Call( 'NewPassword', [ OldPwd, NewPwd ] ) 

  function Synchronize( Pathname, Exchange )
  return Call( 'Synchronize', [ Pathname, Exchange ] ) 

end

return