-------------------------------------------------------------- 
--  VIRT 1.1
--  Subject : DAO. Demo program 
--  Copyright (c) 2000 by A.Baranovsky
--------------------------------------------------------------

/* Property Object, Properties Collection Example

This example creates a user-defined property for the current database, 
sets its Type and Value properties, and appends it to the Properties 
collection of the database. Then the example enumerates all properties 
in the database. 
*/

uses com, dao, daodb, daoengin

CoInitialize()

object DE : DBEngine
object DB : Database
object P : Property
object Properties : Collection

try
  DE.Init( 'DAO.DBEngine.36' )
  DB := DE.OpenDatabase( 'Northwind.mdb', dummy, dummy, dummy )

  P := DB.CreateProperty()
  P.PutName( 'UserDefined' )
  P.PutType( dbMemo )
  P.PutValue( 'This is a user defined property' )

  Properties := DB[ 'Properties' ]

  Properties.Append( P )

  writeln( 'Properties count' )
  writeln( Properties.Count() )

  for I:=0 to Properties.Count() - 1 do
    P := Properties[I]
    writeln( '' )
    write( STR( I ) + ' ' + P.GetName() + ' ' + P.GetStrType() + ' ' )  
    if P.GetType() <> 0 then
      write( P.GetValue() )
      write( ' ' )
      write( P.Inherited() )
    end
  end

  P := Properties[ 'QueryTimeout' ]
  writeln( '' )
  writeln( P.GetValue() )

  Properties.Delete( 'UserDefined' )

finally
  CoUninitialize()
  writeln('')
  writeln( 'COM have closed' )
end

return
