-------------------------------------------------------------- 
--  VIRT 1.1
--  Subject : DAO. Demo program
--  Copyright (c) 2000 by A.Baranovsky
--------------------------------------------------------------

/*This example uses the CreateIndex method to create new Index objects 
and then appends them to the Indexes collection of the ATable TableDef 
object. It then enumerates the Indexes collection of the TableDef object, 
the Fields collection of the new Index objects, and the Properties 
collection of the new Index objects. */

uses com, dao, daodb, daotdef, daoindex, daofield, daoengin

CoInitialize()

object DE : DBEngine
object DB : Database
object TD : TableDef
object Idx : Index
object P : Property
object F : Field
object Properties, Fields, TableDefs, Indexes : Collection

try
  DE.Init( 'DAO.DBEngine.36' )
  DB := DE.OpenDatabase( 'Northwind.mdb', dummy, dummy, dummy )

// Enumerate TableDefs collection.

  TableDefs := DB[ 'TableDefs' ]
  for I:=0 to TableDefs.Count() - 1 do
    TD := TableDefs[ I ]
    writeln( TD.GetName() )
  end

// Create a new TableDef object.

  TD := DB[ 'TableDefs' ][ 'Customers' ]

  writeln( 'Fields of Customers:' )

// Enumerate Fields collection.

  Fields := TD[ 'Fields' ]
  for I:=0 to Fields.Count() - 1 do
    F := Fields[I]
    writeln( F.GetName() + ' ' + F.GetStrType() )
  end

  Indexes := TD[ 'Indexes' ]

/* Create Index object, create and append Field
   objects to the Index object, and then append the
   Index object to the Indexes collection of the TableDef. */

  Idx := TD.CreateIndex( 'NewIndex' )

  Fields := Idx[ 'Fields' ]

  Fields.Append( TD.CreateField( 'City', dbText, 10 ) )

  Indexes.Append( Idx )

// Refresh collection so that you can access new Index object.

  Indexes.Refresh()

// Enumerate Indexes collection.

  for I:=0 to Indexes.Count() - 1 do
    Idx := Indexes[I]
    writeln( Idx.GetName() )
    writeln( '--------------------------------' )

    Properties := Idx[ 'Properties' ]

//  Enumerate Properties collection.

    writeln( 'Properties of ' + Idx.GetName() )

    for J:=0 to Properties.Count() - 1 do
      P := Properties[ J ]
      writeln('') 
      write( P.GetName() + ' as ' + P.GetStrType() + '=' )
      write( P.GetValue() )
    end

    writeln('')
    writeln( 'Press Enter key to continue...' )  
    readln()

//  Enumerate Fields collection.

    writeln( 'Fields of ' + Idx.GetName() )
    Fields := Idx[ 'Fields' ]

    for J:=0 to Fields.Count() - 1 do
      F := Fields[ J ]
      writeln('') 
      write( F.GetName() )
    end

    writeln('')
    writeln( 'Press Enter key to continue...' )  
    readln()
  end

// Delete new Index object since this is a demonstration.

  Indexes.Delete( 'NewIndex' )

  DB.Close()
  
finally
  CoUninitialize()
  writeln('')
  writeln( 'COM have closed' )
end

return
