-------------------------------------------------------------- 
--  VIRT 1.1
--  Subject : DAO. Demo program
--  Copyright (c) 2000 by A.Baranovsky
--------------------------------------------------------------

/*This example enumerates the Documents collection of the Tables container, 
and then enumerates the Properties collection of the first Document object 
in the collection.*/

uses com, dao, daodb, daoengin, daodoc, daocont

CoInitialize()

object DE : DBEngine
object DB : Database
object D : Document
object C : Container
object P : Property
object Containers, Documents, Properties : Collection

try

  DE.Init( 'DAO.DBEngine.36' )
  DB := DE.OpenDatabase( 'Northwind.mdb', dummy, dummy, dummy )

  Containers := DB[ 'Containers' ]
  C := Containers['Tables'] 

  writeln( 'Documents in ' + C.GetName() + ' container:' )

// Enumerate the Documents collection of the Tables container.

  Documents := C[ 'Documents' ]
  for I:=0 to Documents.Count() - 1 do
    D := Documents[ I ]
    writeln( D.GetName() )
  end

  D := Documents[0]

// Enumerate the Properties collection of the first Document object of 
// the Tables container.
   
   writeln( 'Properties of ' + D.GetName() + ' document' )

   Properties := D[ 'Properties' ]
   for I:=0 to Properties.Count() - 1 do
     P := Properties[ I ]
     try
       writeln( P.GetName() + ' ' + P.GetValue() )
     except
     end 
   end

finally
  CoUninitialize()
  writeln('')
  writeln( 'COM have closed' )
end

return
