-------------------------------------------------------------- 
--  VIRT 1.1
--  Subject : DAO. Demo program
--  Copyright (c) 2000 by A.Baranovsky
--------------------------------------------------------------

// This example illustrates the use of the Recordset objects 

uses com, dao, daodb, daoengin, daorec, daofield

function FieldNames( dbName, TableName )
  object &DE : DBEngine
  object DB : Database
  object RS : Recordset
  object Fields : Collection
  object F : Field

  DE == @DBEngine // to get an alias of DBEngine object
  try
    DB := DE.OpenDatabase( dbName, dummy, dummy, dummy )

    try
      RS := DB.OpenRecordset( TableName, dummy, dummy, dummy )

      Fields := RS[ 'Fields' ]
      N := Fields.Count()
      A := array( N )
      for I:=1 to N do
        F := Fields[ I - 1 ]
        A[ I ] := F.GetName()
      end

    finally
      DB.Close()
    end
  except
  end 

return A

CoInitialize()

object DE : DBEngine
object DB : Database
object RS : Recordset
object F : Field

try

  DE.Init( 'DAO.DBEngine.36' )
  DB := DE.OpenDatabase( 'Northwind.mdb', dummy, dummy, dummy )
  RS := DB.OpenRecordset( 'select * from Categories', dbOpenSnapshot, dummy, dummy )

  RS.MoveLast()
  writeln( RS.RecordCount() )

// Enumerate fields.

  for I:=0 to RS.FieldsCount() - 1 do
    F := RS[ 'Fields' ][I]
    writeln( F.GetName() + ' ' + F.GetStrType() )
  end

  F := RS[ 'Fields' ][ 'Description' ]

  writeln( 'Description column is:' )

  RS.MoveFirst()
  while not RS.EOF() do
    writeln( F.GetValue() )
    RS.MoveNext()
  end

//Another way to make the last action:

  RS.MoveFirst()
  while not RS.EOF() do
//  writeln( RS.ReadField( 'Description' ) )
    RS.MoveNext()
  end

  RS.FindFirst( 'Description = "Cheeses" ' )

  if RS.NoMatch() then
    writeln( 'The record is not found' )
  else
    writeln( 'The record is found' )
  end

  RS.Close()

  writeln( 'Press Enter key' )
  Readln()

  RS := DB.OpenRecordset( 'Categories', dbOpenTable, dummy, dummy )

  RS.SetIndex( 'PrimaryKey' )
  RS.Seek( '=', 7 )

  if RS.NoMatch() then
    writeln( 'The record is not found' )
  else
    writeln( 'The record is found' )

    RS.Edit()
    RS.WriteField( 'Description', 'Milk' )
    RS.Update()
  end

  B := RS.Bookmark()

  RS.MoveFirst()
  writeln( RS.ReadField(0) ) 
  RS.MoveBookmark( B )

  writeln( RS.ReadField(0) ) 

  DB.Close()

  A := FieldNames( 'Northwind.mdb', 'Customers' )
  if not Null( A ) then
    writeln( 'Fields of Customers table:' )
    for I:=1 to Card( A ) do
      writeln( A[ I ] )
    end
  end

finally
  CoUninitialize()
  writeln('')
  writeln( 'COM have closed' )
end

return
