-------------------------------------------------------------- 
--  VIRT 1.1
--  Subject : DAO. Recordset object
--  Copyright (c) 2000 by A.Baranovsky
--------------------------------------------------------------

uses dao, daofield

class Recordset : DAOObject
  function "DAOObject"( X )
  function AddNew()
  function Cancel()
  function CancelUpdate()
  function Clone()
  function Close()
  function Delete()
  function Edit()
  function FindFirst( Expression )
  function FindLast( Expression )
  function FindNext( Expression )
  function FindPrevious( Expression )
  function Move( N )
  function MoveFirst()
  function MoveLast()
  function MoveNext()
  function MovePrevious()
  function NextRecordset()
  function OpenRecordset( OpenMode, Options, Lockedits )
  function Requery( NewQueryDef )
  function Seek( Operator, Value )
  function Update()

  function FieldsCount()
  function ReadField( FieldName )
  function WriteField( FieldName, AValue )
  function MoveBookmark( B )

//Properties:
  function SetIndex( IndexName )
  function GetIndex()
  function NoMatch()
  function EOF()
  function BOF()
  function Bookmark()
  function RecordCount()
// Use GetProp and SetProp methods of DAOObject class to read/write 
// another properties of a Recordset object
end

implementation Recordset

  function "DAOObject"( X )
    SetRef( X.GetRef() )
  return Self()

  function ReadField( FieldName )
    object F : Field 
    Fields := GetCollection( 'Fields' )
    F := Fields[ FieldName ]
  return F.GetValue()

  function WriteField( FieldName, AValue )
    object F : Field 
    Fields := GetCollection( 'Fields' )
    F := Fields[ FieldName ]
    F.PutValue( AValue )
  return F

  function FieldsCount()
    object Fields : Collection
    Fields := GetCollection( 'Fields' )
  return Fields.Count()

  function Close()
  return Call( 'Close', [] )

  function AddNew()
  return Call( 'AddNew', [] )

  function Edit()
  return Call( 'Edit', [] )

  function Delete()
  return Call( 'Delete', [] )

  function Update()
  return Call( 'Update', [] )

  function Cancel()
  return Call( 'Cancel', [] )

  function CancelUpdate()
  return Call( 'CancelUpdate', [] )

  function Clone()
    object RS : Recordset
    RS.SetRef( Call( 'Clone', [] ) )
  return RS

  function SetIndex( IndexName )
  return PutProp( 'Index', IndexName )

  function GetIndex()
  return GetProp( 'Index' )

  function Seek( Operator, Value )
  return Call( 'Seek', [Operator, Value] )

  function NoMatch()
  return GetProp( 'NoMatch' )

  function Move( N )
  return Call( 'Move', N )

  function FindFirst( Expression )
  return Call( 'FindFirst', Expression )

  function FindLast( Expression )
  return Call( 'FindLast', Expression )

  function FindNext( Expression )
  return Call( 'FindNext', Expression )

  function FindPrevious( Expression )
  return Call( 'FindPrevious', Expression )

  function MoveFirst()
  return Call( 'MoveFirst', [] )

  function MoveLast()
  return Call( 'MoveLast', [] )

  function MoveNext()
  return Call( 'MoveNext', [] )

  function MovePrevious()
  return Call( 'MovePrevious', [] )

  function NextRecordset()
  return Call( 'NextRecordset', [] )

  function OpenRecordset( OpenMode, Options, Lockedits )
    object RS : Recordset
    RS.SetRef( Call( 'OpenRecordset', [ OpenMode, Options, Lockedits ] ) )
  return RS

  function Requery( NewQueryDef )
  return Call( 'Requery', NewQueryDef )

  function EOF()
  return GetProp( 'EOF' )

  function BOF()
  return GetProp( 'BOF' )
 
  function Bookmark()
  return GetProp( 'Bookmark' )

  function MoveBookmark( B )
  return PutProp( 'Bookmark', B )

  function RecordCount()
  return GetProp( 'RecordCount' )
end

return