-------------------------------------------------------------- 
--  VIRT 1.1
--  Subject : DAO. TableDef object
--  Copyright (c) 2000 by A.Baranovsky
--------------------------------------------------------------

uses dao, daoindex, daofield, daorec

class TableDef : DAOObject
  function "DAOObject"( X )
  function CreateField( FieldName, FieldType, FieldSize )
  function CreateIndex( IndexName )
  function CreateProperty()
  function OpenRecordset( OpenMode, Options, Lockedits )
  function RefreshLink()
//Properties:
  function RecordCount()
// Use GetProp and SetProp methods of DAOObject class to read/write 
// another properties of a TableDef object
end

implementation TableDef

  function "DAOObject"( X )
    SetRef( X.GetRef() )
  return Self()

  function CreateField( FieldName, FieldType, FieldSize )
    object F : Field 
    F.SetRef( Call( 'CreateField', [ FieldName, FieldType, FieldSize ] ) )
  return F

  function CreateIndex( IndexName )
    object Idx : Index
    Idx.SetRef( Call( 'CreateIndex', [ IndexName ] ) )
  return Idx

  function CreateProperty()
    object P : Property
    P.SetRef( Call( 'CreateProperty', [] ) )
  return P

  function OpenRecordset( OpenMode, Options, Lockedits )
    object RS : Recordset
    RS.SetRef( Call( 'OpenRecordset', [ OpenMode, Options, Lockedits ] ) )
  return RS

  function RefreshLink()
  return Call( 'RefreshLink', [] ) 

  function RecordCount()
  return GetProp( 'RecordCount' )
end

return