-------------------------------------------------------------- 
--  VIRT 1.1
--  Subject : DAO. User and Group objects
--  Copyright (c) 2000 by A.Baranovsky
--------------------------------------------------------------

uses dao

class User : DAOObject
  function "DAOObject"( N )
  function CreateGroup( Name )
  function NewPassword( OldPwd, NewPwd )
//Properties:
  function GetPassword()
  function PutPassword( X )
  function GetPID()
  function PutPID( X )
end

class Group : DAOObject
  function "DAOObject"( N )
  function CreateUser( Name )
//Properties:
  function GetPID()
  function PutPID( X )
end

implementation User

  function "DAOObject"( X )
    SetRef( X.GetRef() )
  return Self()

  function CreateGroup( Name )
    object G : Group
    G.SetRef( Call( 'CreateGroup', [ Name ] ) )
  return G

  function NewPassword( OldPwd, NewPwd )
  return Call( 'NewPassword', [ OldPwd, NewPwd ] ) 

  function GetPassword()
  return GetProp( 'Password' )

  function PutPassword( X )
  return PutProp( 'Password', X )

  function GetPID()
  return GetProp( 'PID' )

  function PutPID( X )
  return PutProp( 'PID', X )
end

implementation Group

  function "DAOObject"( X )
    SetRef( X.GetRef() )
  return Self()

  function CreateUser( Name )
    object U : User
    U.SetRef( Call( 'CreateUser', [ Name ] ) )
  return U

  function GetPID()
  return GetProp( 'PID' )

  function PutPID( X )
  return PutProp( 'PID', X )
end

return